UNIT Brow_Win;

INTERFACE
USES
  BiosCrt, Strings, Monitor, Mouse, Brow_var, Bro_tool;


PROCEDURE MsgBox (Txt : String);
PROCEDURE SaveWindow;
PROCEDURE CloseWindow;


IMPLEMENTATION
VAR
  OldX, OldY, OldWinMin, OldWinMax, OldAttr : Word;


FUNCTION BreakStaticText (Txt : String; MaxWidth : Byte) : String;
VAR
  x, l, p : Byte;
  IsSpace : Boolean;
BEGIN
  l:= 0;
  isSpace:= FALSE;
  x:= 1;
  While x<Length(Txt) Do
  BEGIN
    CASE Txt[x] Of
      #10 : l:= 0;
      ' ' : BEGIN p:= x; isSpace:= TRUE; END;
    END;
    inc (l);
    If l>=MaxWidth Then
    BEGIN
      If isSpace Then Txt[p]:= #10 Else insert (#10, Txt, x);
      isSpace:= FALSE;
      l:= 0;
    END;
    inc (x);
  END;

  BreakStaticText:=Txt;
END;
{ Zeilenumbrche einfgen }


FUNCTION StaticTextSize (Txt : String; MinWidth : Byte) : Word;
VAR
  w, x, l : Byte;
  h       : Word;
  s       : String;
BEGIN
  h:= CountFields (Txt, #10);
  If h>18 Then h:= 18;
  w:= MinWidth;
  For x:= 1 To h Do
  BEGIN
    s:= nthField (Txt, #10, x);
    l:= Length (s);
    If s[Length(s)]=#13 Then dec (l);
    If w<l Then w:= l;
  END;
  If w>68 Then w:= 68;
  StaticTextSize:= h shl 8 + w;   { hi=Hhe, lo=Breite }
END;



FUNCTION Center (Left, Right, ObjektLen : Byte) : Byte;
BEGIN
  Center:= (Right-Left) shr 1 + Left - ObjektLen shr 1;
END;


PROCEDURE StaticText (a, b, c, d : Byte; Txt : String);
VAR
  ml, x : Byte;
  s     : String[80];
BEGIN
  x:= CountFields (Txt, #10);
  If x>d-b+1 Then x:=d-b+1;
  ml:= c-a+1;
  For x:= 1 To x Do
  BEGIN
    s:= nthField (Txt, #10, x);
    If s[Length(s)]=#13 Then dec (s[0]);
    s:= copy (s, 1, ml);
    WriteXY (a, b-1+x, s, nBlack, nLightGray);
  END;
END;


PROCEDURE Button (a, b : Byte; Txt : String);
VAR
  x, i, l : Byte;
BEGIN
  Txt:= '  '+Txt+'  ';
  l:= Length(Txt);
  i:= 1;
  For x:= a To a+l-1 Do
  BEGIN
    If Konfig.ColMode<>'B' Then
    CharXY (x, b, Txt[i], 14, 1) Else CharXY (x, b, Txt[i],  0, 7);
    CharXY (x+1, b+1, #223, 0, nLightGray);
    inc (i);
  END;
  CharXY (a+l, b, #220, 0, nLightGray);
END;


PROCEDURE SaveWindow;
BEGIN
  OldWinMin:= WindMin;
  OldWinMax:= WindMax;
  OldX:= WhereX;
  OldY:= WhereY;
  OldAttr:= TextAttr;
END;


PROCEDURE OpenWindow (a, b, c, d : Byte; Title : String);
BEGIN
  SaveWindow;
  Window (a, b, c, d);
  TextAttr:= (nLightGray shl 4) + nBlack;
  ClrScr;
  Textattr:= (nDarkGray shl 4) + Yellow;
  ClrEol;
  Window (a+2, b+2, c, d);
  WriteXY (Center (a, c, Length (Title)), b, Title, yellow, nDarkGray);
  Schatten25 (a, b, c, d);
END;


PROCEDURE CloseWindow;
BEGIN
  WindMin:= OldWinMin;
  WindMax:= OldWinMax;
  GotoXY (OldX, OldY);
  TextAttr:= OldAttr;
END;


PROCEDURE MsgWindow (Head, Txt : String);
VAR
  hw         : Word;
  a, b, c, d : Byte;
BEGIN
  Txt:= BreakStaticText (Txt, 65);
  hw:= StaticTextSize (Txt, Length(Head));
  a:= Center (1, 80, lo (hw))-2; If a<1 Then a:= 1;
  b:= Center (1, 25, hi (hw))-2; If b<1 Then b:= 1;
  c:= a+5+lo(hw);
  d:= b+4+hi(hw);
  OpenWindow (a, b, c, d, Head);
  StaticText (a+3, b+2, c, d, Txt);
  Button (center (a, c, 8), d-1, 'Okay');
  REPEAT
    GetKey1;
  UNTIL (t1=#13)
  or ((kn<>0) and (MouseIn (center (a, c, 8), d-1, center (a, c, 8)+7, d-1)));
  CloseWindow;
END;


PROCEDURE MsgBox (Txt : String);
BEGIN
  MsgWindow ('JavaScript-Meldung', Txt);
END;

END.


{
Copyright (C) 1994-2002 Andre Olejko - olejko.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2, as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
