PROGRAM ChkDir;
{$M 60000, 0, 0}


USES
  dos, strings, bioscrt, masken, hexbin, disk, filecopy;

VAR
  tg       : Searchrec;
  Suchpfad : PathStr;
  x, y, z  : Word;
  a        : String[20];
  ClustSize: Word;
  k2       : LongInt;
  PStat    : Word;
  DSize    : LongInt;

CONST
  LW       : Char    = #0;
  Gesamt   : LongInt = 0;
  k1       : LongInt = 0;
  b        : array[1..3]Of String[8]=('Byte :  ','Kilo :  ', 'Mega :  ');



PROCEDURE Stop (Txt : String; ErrCode : Word);
BEGIN
  DosLnLF (Txt);
  BlindStop; Halt (ErrCode);
END;



PROCEDURE Hilfetext;
CONST
s1='ermittelt Gesamtgre und Speicherverbrauch eines Verzeichnisses samt'#13#10+
   'Unterverzeichnissen'#13#10#13#10+
   'CHKDIR [Verzeichnis] [Test-Laufwerk]'#13#10;

s2='Wenn Sie ein [Testlaufwerk] angeben, knnen Sie ermitteln, ob das Verzeichnis'#13#10+
   'auf diesen Datentrger passen wrde (wenn dieser leer wre). Fehlt'#13#10+
   'Verzeichnis, wird das aktuelle Verzeichnis untersucht.'#13#10;

s3='Mgliche Errorlevel beim Beenden von CHKDIR:'#13#10#13#10+
   '1 = Verzeichnis nicht gefunden'#13#10+
   '2 = Objekt ist eine Datei'#13#10+
   '3 = Test-Laufwerk nicht bereit'#13#10+
   '4 = Verzeichnis pat nicht auf das Test-Laufwerk'#13#10+
   '0 = keiner der genannten Fehler ist aufgetreten';

BEGIN
  DosLnLF (#13#10'CHKDIR  '+Copyright);
  DosLnLF (s1);
  DosLnLF (s2);
  Stop    (s3, 1);
END;


PROCEDURE GetClusterSize (LW : Char); assembler;
ASM
  mov ah, $36
  mov dl, LW
  sub dl, 64
  int $21
  mul cx
  mov ClustSize, ax
END; {Sektoren Pro Cluster in ax, Anzahl Bytes pro Sektor in cx}
     {ist 0, wenn ungltiges Laufwerk}


PROCEDURE Rekursiv (SuchPfad: PathStr);
VAR
  t : Searchrec;
BEGIN
  Findfirst (Vollpfad (Suchpfad, '*.*'), normalfile, t);
  While (DOSError = 0) Do
  BEGIN
    If t.name[1]<>'.' Then
    BEGIN
      If (t.attr and directory <> 0) Then
      BEGIN
        If LW<>#0 Then inc (k1, ClustSize);
        Rekursiv (VollPfad (Suchpfad, t.name));
      END Else
      BEGIN
        inc (Gesamt, t.size);
        If LW<>#0 Then
        inc (k1, (t.Size DIV ClustSize + ord (t.Size MOD ClustSize<>0)) * ClustSize);
      END;
    END;
    Findnext (t);
  END;
END;



{---------------------------- HauptProgramm --------------------------------}

BEGIN
  Suchpfad:= UpStr (ParamStr (2));
  If SuchPfad<>'' Then LW:= SuchPfad[1];
  If LW<>#0 Then
  BEGIN
    If Drive (LW) and CDDrive<>0 Then
    Stop ('CD-ROM als Testlaufwerk nicht verwendbar', 3) Else
    If Drive (LW) and PhantomDrive<>0 Then
    Stop (#13#10'Phantom-Laufwerk als Testlaufwerk nicht verwendbar', 3) Else
    If Drive (LW) = NoDrive Then
    Stop (#13#10'Testlaufwerk existiert nicht', 3) Else
    BEGIN
      DSize:=DskSize (ord(LW) and 31);
      If DSize=-1 Then Stop (#13#10'Testdatentrger nicht bereit', 3);
      GetClusterSize (LW);
    END;
  END;

  Suchpfad:= UpStr (ParamStr (1));
  If SuchPfad='/?' Then Hilfetext;

  SuchPfad:= FileExPand (Suchpfad);
  PStat:= PathStatus (SuchPfad, CheckQuelle);
  If PStat<>0 Then 
  Stop (SuchPfad[1]+': '+PathStatusStr (PStat), 1);

  DosLnLF (#13#10'Gre aller Dateien im Verzeichnis: ');
  DosLnLF (SuchPfad); DosLnLF ('');

  FindFirst (Suchpfad, normalfile, tg);
  If DOSerror+(tg.attr and directory)=0 Then
  Stop ('Objekt ist eine Datei', 2);

  FindFirst (VollPfad (Suchpfad, '*.*'), normalfile, tg);
  If DOSerror <>  0 Then
  If DOSError >= 150 Then
  Stop (CopyResultStr (DosError), 1) Else
  Stop ('Verzeichnis nicht gefunden', 1);

  Rekursiv (Suchpfad);

  For x:= 1 To 3 Do
  BEGIN
    DosStr (b[x]); DosLnLF (TausPkt (Gesamt));
    Gesamt:= ShiftRight (Gesamt, 10);
  END;

  If LW<>#0 Then
  BEGIN
    DosLnLF (#13#10'tatschlicher Speicherplatzverbrauch auf Datentrger in '+LW+':'#13#10);
    k2:= k1;
    For x:= 1 To 3 Do
    BEGIN
      DosStr (b[x]); DosLnLF (TausPkt (k1));
      k1:= ShiftRight (k1, 10);
    END;

    DosLnLF ('');
    If k2>DSize Then
    Stop   ('Verzeichnis wrde nicht auf den Datentrger passen.', 4) Else
    DosStr ('Verzeichnis wrde auf den Datentrger passen.');
  END;
  Stop ('', 0);
END.






{
Copyright (C) 1994-2002 Andre Olejko - olejko.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2, as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
