UNIT Back_cop;

INTERFACE
USES
  cmd_var, dos, strings, bioscrt;

VAR
  TempF   : Text;
  FileNum : Word;

CONST
  FatalCError : Byte = 0;

PROCEDURE TempFile_Anlegen;


IMPLEMENTATION


PROCEDURE GetFInfo (Suchpfad : PathStr; t1 : Searchrec);
VAR
  Baum : PathStr;
BEGIN
  tg:=t1;
  Quelle:= Suchpfad;
  Baum  := Copy (Quelle, UrDirL+1, Length(Quelle)-UrDirL);
  If Baum[1]='\' Then delete (Baum, 1, 1);
  Ziel:= Vollpfad (RC.FensterPfad[ax1], Baum);
END; 


PROCEDURE MakeTemp_Proc;
BEGIN
  WriteLn (TempF, Quelle);
  WriteLn (TempF, Ziel);
  inc (FileNum);
END;


PROCEDURE Rekursiv (SuchPfad: PathStr);
VAR
  new_dir : PathStr;
  tg      : Searchrec;
BEGIN
  Findfirst (Vollpfad(Suchpfad,'*.*'), anyfile and not VolumeID, tg);
  While (DOSError = 0) Do
  BEGIN
    New_dir:= VollPfad (suchpfad, tg.name);
    If tg.name[1]<>'.' Then
    BEGIN
      GetFinfo (New_Dir, tg);
      MakeTemp_Proc;
      If tg.attr and directory <> 0 Then Rekursiv (new_dir);
    END;
    Findnext (tg);
  END;
END;


FUNCTION SamePath (Name : FStr) : Boolean;
VAR
  t : Byte;
BEGIN
  If (pos (VollPfad (RC.FensterPfad[ax], Name)+'\', RC.FensterPfad[ax1]+'\') <> 0)
  or (RC.FensterPfad[1]=RC.FensterPfad[2]) Then t:=1 Else t:=0;
  SamePath:= t=1;
END;


PROCEDURE Datei_Op (Name: Fstr);
VAR
  Suchpfad : PathStr;
  tx       : Searchrec;
BEGIN
  If (Name[1]='.') or ((Samepath (Name)) and (XBefehl<>1)) Then
  BEGIN FatalCError:=1; Close (TempF); OutChar (#7); EXIT; END;

  UrDirL   := Length (RC.FensterPfad[ax]);
  Suchpfad := Vollpfad (RC.FensterPfad[ax], Name);

  FindFirst (Suchpfad, anyfile, tx);
  If DOSerror=0 Then GetFInfo (Suchpfad, tx) Else
  BEGIN FatalCError:=1; Close (TempF); OutChar (#7); Exit; END;

  MakeTemp_Proc;
  If tx.attr and directory <> 0 Then Rekursiv (Suchpfad);
END;


{------------------------------ HauptProzedur -------------------------------}

PROCEDURE TempFile_anlegen;
VAR
  ddx : Integer;

BEGIN
  Sign:=25; FileNum:=0; ddx:=0;
  If (ii=0) or (RC.FensterPfad[ax] = RC.FensterPfad[ax1]) Then
  BEGIN FatalCError:=1; OutChar (#7); Exit; END;

  Assign (TempF, VollPfad (TempPath, 'BACK_COP.TMP'));
  SetFAttr (TempF, 32); ReWrite(TempF); If IOResult<>0 Then
  BEGIN FatalCError:=1; OutChar (#7); Exit; END;

  If ij[ax]=0 Then Datei_Op (Listen [dd].Dateiname) Else
  REPEAT
    inc (ddx);
    If collect[ax, ddx]=#219 Then
    BEGIN
      dec (ij[ax]);
      Datei_Op (Listen[ddx].Dateiname);
    END;
  UNTIL (ij[ax]<= 0) or (ddx>=ii);
  Close (TempF);
END;


END.




{
Copyright (C) 1994-2002 Andre Olejko - olejko.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2, as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
