UNIT Run_Stri;

INTERFACE
USES
  Run_var, crt, run_moni, mouse, run_tool, run_if, printer, Strings;


PROCEDURE MoveVariable;
FUNCTION  AddString (ein : String) : String;
PROCEDURE GetNumbers (ein : String; Num : Byte);
PROCEDURE GetUnitNames;
PROCEDURE WriteStr;
PROCEDURE FillWin;
PROCEDURE Print;


IMPLEMENTATION




PROCEDURE InsertInString (c : Char; Num : String);
VAR
  w   : Byte;
  tmp : String;
BEGIN
  StrCopy (Trim (copy (Line, 1, pos (':=', Line)-1)), tmp);
  If pos ('[', tmp) = 0 Then StrCopy (GetFuncString (Num), vStrgArr[c]) Else
  BEGIN
    w:= Byte (GetEckKlammerWord (tmp));
    If w > Length (vStrgArr[c]) Then ErrorMsg (Line, 'aktuelle Stringlnge kleiner als Index');
    vStrgArr[c, w]:= GetFuncChar (Num);
  END;
END;



PROCEDURE InsertInBlock (Num : String);
VAR
  w : Word;
BEGIN
  w:= GetEckKlammerWord (Trim (copy (Line, 1, pos (':=', Line)-1)));
  If w>SizeOf(Block) Then
  ErrorMsg (Line, 'Der Blockindex mu eine Zahl zwischen 0 und '+LZ(SizeOf(Block))+' sein');
  Block[w]:= GetFuncChar (Num);
END;



PROCEDURE InsertInMem (Num : String);
VAR
  a, b   : Byte;
  tmp    : String;
  w1, w2 : Word;
  lon    : LongInt;
BEGIN
  StrCopy (Trim (copy (Line, 1, pos (':=', Line)-1)), tmp);
  a:= pos     ('[', tmp);
  b:= lastpos (']', tmp);
  StrCopy (Trim (copy (tmp, a+1, b-a-1)), tmp);
  a:= pos (':', tmp);
  If a= 0 Then ErrorMsg (Line, '- Adress-Element fehlt.');
  w1 := word (GetFuncLong (Trim (copy (tmp, 1, a-1))));
  w2 := word (GetFuncLong (Trim (copy (tmp, a+1, 100))));
  lon:= GetFuncLong (Num);
  If xpos ('%MEML')=0 Then MemL [w1 : w2]:=       Lon  Else
  If xpos ('%MEMW')=0 Then MemW [w1 : w2]:= Word (Lon) Else
  If xpos ('%MEM' )=0 Then Mem  [w1 : w2]:= Byte (Lon);
END;





PROCEDURE InsertInPort (Num : String);
VAR
  w   : Word;
  tmp : String;
BEGIN
  StrCopy (Trim (copy (Line, 1, pos (':=', Line)-1)), tmp);
  w:= GetEckKlammerWord (tmp);
  If pos ('%PORTW', tmp)=1 Then PortW [w]:= Word (GetFuncLong (Num)) Else
  If pos ('%PORT' , tmp)=1 Then Port  [w]:= Byte (GetFuncLong (Num));
END;




PROCEDURE MoveVariable;
VAR
  Num  : String;
  c    : Char;
  a, b : Word;
BEGIN
  a:= Seg(Line); b:= ofs(Line);

  c:= Line[2];
  If (c>'Z') or (c<'A') Then ErrorMsg (Line, 'Fehler in Variablenname');
  StrCopy (Trim(Copy (Line, pos ('=', Line) + 1, MaxLen)), Num);

  If xpos ('@TEXTATTR'   ) = 0 Then TextAttr       := Byte (GetFuncLong (Num)) Else
  If xpos ('@FREAD'      ) = 0 Then gelesen        := Word (GetFuncLong (Num)) Else
  If xpos ('@WINDMIN'    ) = 0 Then WindMin        := Word (GetFuncLong (Num)) Else
  If xpos ('@WINDMAX'    ) = 0 Then WindMax        := Word (GetFuncLong (Num)) Else
  If xpos ('@DIRECTVIDEO') = 0 Then DirectVideo    := Boolean (Byte(GetFuncLong (Num))) Else
  If xpos ('@CHECKSNOW'  ) = 0 Then CheckSnow      := Boolean (Byte(GetFuncLong (Num))) Else
  If xpos ('@RESULT'     ) = 0 Then BEGIN LongRes  := GetFuncLong (Num);   FuncRes:= 1; END Else
  If xpos ('!RESULT'     ) = 0 Then BEGIN StrCopy (GetFuncString (Num), StringRes); FuncRes:= 2; END Else
  If xpos ('#RESULT'     ) = 0 Then BEGIN CharRes  := GetFuncChar (Num);   FuncRes:= 3; END Else
  If xpos ('#KEY2'       ) = 0 Then t2:= GetFuncChar (Num) Else
  If xpos ('#KEY'        ) = 0 Then t1:= GetFuncChar (Num) Else

  CASE Line[1] Of
    '@'      : vLongArr[c]:= GetFuncLong   (Num);
    '#'      : vCharArr[c]:= GetFuncChar   (Num);
    '!'      : InsertInString (c, Num);
    ''''     : StrCopy (GetFuncString (Num), vStrgArr[c]);
    '%'      : If xpos ('%BLOCK'   )=0 Then InsertInBlock (Num) Else
               If xpos ('%MEM'     )=0 Then InsertInMem   (Num) Else
               If xpos ('%PORT'    )=0 Then InsertInPort  (Num) Else
               If xpos ('%DATETIME')=0 Then
               BEGIN
                 If pos ('.YEAR',     Line)<> 0 Then DatTim.Year      := Word(GetFuncLong (Num)) Else
                 If pos ('.MONTH',    Line)<> 0 Then DatTim.Month     := Word(GetFuncLong (Num)) Else
                 If pos ('.DAY',      Line)<> 0 Then DatTim.day       := Word(GetFuncLong (Num)) Else
                 If pos ('.DAYOFWEEK',Line)<> 0 Then DatTim.dayofweek := Word(GetFuncLong (Num)) Else
                 If pos ('.HOUR',     Line)<> 0 Then DatTim.hour      := Word(GetFuncLong (Num)) Else
                 If pos ('.MIN',      Line)<> 0 Then DatTim.min       := Word(GetFuncLong (Num)) Else
                 If pos ('.HUNSEC',   Line)<> 0 Then DatTim.hunsec    := Word(GetFuncLong (Num)) Else
                 If pos ('.SEC',      Line)<> 0 Then DatTim.sec       := Word(GetFuncLong (Num)) Else
                 ErrorMsg (Line, 'ungltiges Datums- oder Zeitfeld');
               END Else;
  END;
END;



FUNCTION AddString (ein : String) : String;
VAR
  tmp : String;
  x   : Byte;
BEGIN
  GetArguments (GetKlammerString (ein));
  CheckVariab;
  tmp:= '';
  For x:= 1 To ArgNum Do StrAdd (tmp, StrArr[x]);
  AddString:= tmp;
END;
{Stellt aus dem Stringarray den auszugebenden String her}




PROCEDURE GetNumbers (ein : String; Num : Byte);
VAR
  x : Byte;
BEGIN
  GetArguments (GetKlammerString (ein));
  If (ArgNum<>Num) Then ErrorMsg (Line, ParamNumError);
  For x:= 1 To ArgNum Do NumArr[x]:= GetFuncLong (StrArr[x]);
END;



PROCEDURE GetUnitNames;
BEGIN
  i:= 1;
  While (i < LineNum) and (pos ('USES', TLine[i]^)=0) Do inc (i);
  If i>=LineNum Then BEGIN ArgNum:= 0; Exit; END;
  GetArguments (GetProcName (TLine[i]^));
  For i:= 1 To ArgNum Do
  If pos ('.', StrArr[i]) = 0 Then StrAdd (StrArr[i], '.UNI');
END;



PROCEDURE WriteStr;
BEGIN
  If xpos ('WRITELN') = 0 Then
  WriteLn (AddString (Line)) Else Write (AddString(Line));
END;



PROCEDURE Print;
BEGIN
  If xpos ('PRINTLN') = 0 Then
  Write (Lst, AddString (Line), #13#10) Else
  Write (Lst, AddString (Line));
  Error:= IOResult;
END;



PROCEDURE FillWin;
VAR
  x, y : Byte;
  fill : String;
BEGIN
  GotoXY (1, 1);
  StrCopy (AddString (Line), Fill);
  For x:= CopArr[1] To CopArr[3] Do For y:= CopArr[2] To CopArr[4] Do
  WriteXY (x, y, Fill, vc, hc);
END;


END.

{
Copyright (C) 1994-2002 Andre Olejko - olejko.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2, as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
