UNIT Dosx;

INTERFACE

USES
  DOS;

PROCEDURE InitDosWin (WinA, WinB, WinC, WinD : Byte);
PROCEDURE DoneDosWin;

PROCEDURE DosShell    (Command : String);
PROCEDURE DosShellWin (x1, y1, x2, y2 : byte; Command : String);

VAR
  ComCom : PathStr;    { Pfad der Command.com, ermittelt UNIT selbst }

IMPLEMENTATION

VAR
  OldInt29       : Pointer;
  WinMin, WinMax : Word;


PROCEDURE DosWin; assembler;
ASM
  push ds; push ax; push bx; push cx; push dx
  mov  bx, Seg @Data
  mov  ds, bx
  pushf
  call dword ptr OldInt29     { Alten Int-Handler aufrufen }

  mov  ah, 3                  { Cursor-Position ermitteln }
  xor  bh, bh
  int  10h

  mov  cx, WinMin
  mov  bx, WinMax
  cmp  dl, cl                 { linker Rand berschrieben ? }
  jae  @1                     { wenn nicht, weiter }
  mov  dl, cl                 { sonst Cursor an linken Fensterrand setzen }

@1:
  cmp  dl, bl                 { rechter Rand berschrieben ? }
  jbe  @2                     { wenn nicht, weiter }
  mov  dl, cl                 { sonst Zeilenumbruch erzeugen }
  inc  dh

@2:
  cmp  dh, ch                 { oberer Rand berschrieben ? }
  jae  @3                     { wenn nicht, weiter }
  mov  dh, ch                 { sonst Cursor an oberen Fensterrand setzen }

@3:
  cmp  dh, bh                 { unterer Rand berschrieben ? }
  jbe  @4                     { wenn nicht, weiter }

  mov  dh, bh
  push dx                     { sonst Bildschirm scrollen }
  mov  dx, bx
  mov  ah, 8                  { Bildschirmfarbe ermitteln }
  xor  bh, bh
  int  10h
  mov  bh, ah                 { Farbe in BH }
  mov  ax, 0601h              { Bildschirm nach oben scrollen }
  int  10h
  pop  dx

@4:
  mov  ah, 2                  { Cursor an neue Position setzen }
  xor  bh, bh
  int  10h

  pop  dx; pop cx; pop bx; pop ax; pop ds
  IRET
END;


PROCEDURE InitDosWin (WinA, WinB, WinC, WinD : Byte); assembler;
ASM
  mov  al, WinA
  mov  ah, WinB
  dec  al
  dec  ah
  mov  WinMin, ax
  mov  bl, WinC
  mov  bh, WinD
  dec  bl
  dec  bh
  mov  WinMax, bx

  mov  dx, ax                 { Cursor in linke obere Ecke }
  mov  ah, 2
  xor  bh, bh
  int  10h

  mov  ax, 3529h                  { GetIntVec 29h }
  int  21h
  mov  Word Ptr OldInt29   , bx   { Speichere alten Vektor }
  mov  Word Ptr OldInt29[2], es
  push ds
  mov  ax, Seg    DosWin
  mov  ds, ax
  mov  dx, Offset DosWin          { DS:DX = neue Int-29h-Routine }
  mov  ax, 2529h                  { SetIntVec 29h }
  int  21h
  pop  ds
END;


PROCEDURE DoneDosWin; assembler;
ASM
  push ds
  lds  dx, OldInt29
  mov  ax, 2529h                  { SetIntVec 29h }
  int  21h                        { Alte Int-29h-Routine wieder einsetzen }
  pop  ds
END;



PROCEDURE ChangeHeapSize (HeapSize : Pointer); assembler;
ASM
  mov bx, word ptr HeapSize
  add bx, 15
  mov cl, 4
  shr bx, cl
  add bx, word ptr HeapSize[2]
  mov ax, PrefixSeg
  sub bx, ax
  mov es, ax
  mov ah, 4Ah
  int 21h
  jnc @ende
  mov word ptr DosError, -1
  @ende:
END;


PROCEDURE DosShell (Command : String);
BEGIN
  DosError:= 0;
  ChangeHeapSize (HeapPtr); If DosError=-1 Then Exit;
  If Command<>'' Then insert ('/C ', Command, 1);
  SwapVectors;
  Exec (ComCom, Command);
  SwapVectors;
  ChangeHeapSize (HeapEnd);
END;


PROCEDURE DosShellWin (x1, y1, x2, y2 : byte; Command : String);
BEGIN
  InitDosWin (x1, y1, x2, y2);
  DosShell (Command);
  DoneDosWin;
END;


BEGIN
  ComCom:= GetEnv ('COMSPEC');
END.




{
Copyright (C) 1994-2002 Andre Olejko - olejko.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2, as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
