UNIT SPC;    {packen und entpacken im SPACE-Format}

INTERFACE



PROCEDURE UnPackText (VAR Quelle, Ziel; QSize : Word; VAR ZSize);
PROCEDURE PackText   (VAR Quelle, Ziel; QSize : Word; VAR ZSize); 

FUNCTION  PackedString   (ein : String) : String;
FUNCTION  UnPackedString (ein : String) : String;


IMPLEMENTATION



PROCEDURE UnPackText (VAR Quelle, Ziel; QSize : Word; VAR ZSize); assembler;
ASM
  mov bx, ds
  les di, Ziel
  mov dx, di

  mov cx, QSize
  or  cx, cx
  jz  @raus

  cld
  lds si, Quelle
  inc cx
  jmp @start

@Anfang:
  StosB
  jmp @Start

@Beginn:
  StosW                                           

@Start:
  dec cx
  jz @raus
  LodsB                     {al=13, ah=10}
       cmp al,   1; jne @p1; mov ax, 2573;jmp @Beginn;
  @p1: cmp al,   0; jne @p2; mov al, ''; jmp @Anfang;
  @p2: cmp al,  27; jne @p3; mov al, ''; jmp @Anfang; 
  @p3: cmp al,  28; jne @p4; mov al, ''; jmp @Anfang;
  @p4: cmp al,  29; jne @pa; mov al, ''; jmp @Anfang;
  @pa: cmp al,  30; jne @py; mov al, ''; jmp @Anfang; 
  @py: cmp al,  31; jne @p5; dec cx;
                             jz @raus;
                             Lodsb;       jmp @Anfang;


  @p5: cmp al,  26; ja  @p6; add al,  96; mov ah, ' '; jmp @Beginn;
  @p6: cmp al, 128; jb  @Anfang
       cmp al, 152; ja  @p7; sub al,  30; mov ah, 's'; jmp @Beginn;
  @p7: cmp al, 155; jb  @Anfang
       cmp al, 179; ja  @p8; sub al,  57; mov ah, 'e'; jmp @Beginn;
  @p8: cmp al, 204; ja  @p9; sub al,  82; mov ah, 'h'; jmp @Beginn;
  @p9: cmp al, 230; ja  @p0; sub al, 107; mov ah, 'a'; jmp @Beginn;
  @p0:                       sub al, 133; mov ah, 'i'; jmp @Beginn;

  @raus:
  mov ds, bx
  mov ax, di
  sub ax, dx

  les di, ZSize
  StosW
END;

{Quelle und Ziel : Beliebige Datenstruktur}
{QSize : Gre der Quellstruktur oder Zahl der zu entpackenden Bytes}
{ZSize : Zahl der entpackten Bytes. Sollte vom Typ WORD sein}



PROCEDURE PackText (VAR Quelle, Ziel; QSize : Word; VAR ZSize); Assembler;
ASM
  push ds

  les di, Ziel
  mov dx, di
  mov cx, QSize
  or  cx, cx
  jz  @raus

  cld
  lds si, Quelle
  mov bx, si
  add bx, cx
  jmp @Start
  
@Anfang:
  dec cx
  jz @raus
  inc si

@Beginn:
  dec si
  StosB
  dec cx
  jz @raus

@Start:
  LodsW

       cmp al, 13 ;  jne @py; cmp si, bx; ja @px;
       cmp ah, 10 ;  jne @px; mov al, 1;         jmp @Anfang;
  @py: cmp al, 31 ;  jbe @px;
       cmp al, 'b';  jb  @Beginn;   cmp al, 'z'; jbe @Weiter;

       cmp al, '';  jne @p1;       mov al,  27; jmp @Beginn;
  @p1: cmp al, '';  jne @p2;       mov al,  28; jmp @Beginn;
  @p2: cmp al, '';  jne @p3;       mov al,  29; jmp @Beginn;
  @p3: cmp al, '';  jne @p4;       mov al,  30; jmp @Beginn;
  @p4: cmp al, '';  jne @pz;       mov al,   0; jmp @Beginn;
  @pz:
       cmp al, 127;  jbe @Beginn;
       cmp al, '';  je  @Beginn;
       cmp al, '';  je  @Beginn;   
  @px: mov byte ptr es:[di], 31;    inc di;      jmp @Beginn;

  @weiter:
       cmp si,  bx;  jae @Beginn
       cmp ah, ' ';  jne @p6;       sub al,  96; jmp @Anfang;
  @p6: cmp ah, 'a';  jne @p7;       add al, 107; jmp @Anfang;
  @p7: cmp ah, 'e';  jne @p8;       add al,  57; jmp @Anfang;
  @p8: cmp ah, 'h';  jne @p9;       add al,  82; jmp @Anfang;
  @p9: cmp ah, 'i';  jne @p0;       add al, 133; jmp @Anfang;
  @p0: cmp ah, 's';  jne @Beginn;   add al,  30; jmp @Anfang;

  @raus:
  pop ds
  mov ax, di
  sub ax, dx

  les di, ZSize
  StosW
END;



FUNCTION PackedString (ein : String) : String;
VAR
  tmp    : String;
  NewLen : Word;
BEGIN
  PackText (ein[1], tmp[1], Length (ein), NewLen);
  tmp[0]:= chr (lo(NewLen));
  PackedString:= tmp;
END;



FUNCTION UnPackedString (ein : String) : String;
VAR
  tmp    : String;
  NewLen : Word;
BEGIN
  UnPackText (ein[1], tmp[1], Length (ein), NewLen);
  tmp[0]:= chr (lo(NewLen));
  UnPackedString:= tmp;
END;



END.

{
Copyright (C) 1994-2002 Andre Olejko - olejko.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2, as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
}
